#!/bin/bash

if [[ $EUID -ne 0 ]]; then
	echo "ERROR: This installer must be run as root!"
	exit 1
fi

#Constants that are overwritten by the build script
install_type="install"
os_type="linux_rpm_64"
exe_filename="ChronicallAppsSetup"
setup_jar_name="setup.jar"
brand="Avaya"

#Constants that are not edited
setup_jar="`pwd`/lib/$setup_jar_name"

#Give Chronicall programs executable permissions
chmod +x bin/ChronicallDatabaseOrientDB
chmod +x bin/ChronicallDataGrid
chmod +x bin/ChronicallDataGridNode
chmod +x bin/ChronicallMultimedia
chmod +x bin/ChronicallRecordingLibrary
chmod +x bin/ChronicallRealtimeNode
chmod +x bin/ChronicallServer
chmod +x bin/ChronicallSetup
chmod +x bin/ChronicallUpdate
chmod +x bin/ChronicallAppsSetup
chmod +x bin/ChronicallUninstall

chmod +x bin/ChronicallServerStart.sh
chmod +x bin/ChronicallServerStop.sh
chmod +x bin/ChronicallServerRestart.sh
chmod +x bin/ChronicallOrientDbStart.sh
chmod +x bin/ChronicallOrientDbStop.sh
chmod +x bin/ChronicallOrientDbRestart.sh

#Translate Linux Style Options to Chronicall Expected Format: "key=value"
args_index=0
last_param=""
for arg in "$@"
do
	if [ ${arg:0:1} == "-" ] #If the first character is '-' then this arg is a key
	then
		if [ "$last_param" == "" ]
		then
			last_param="$arg"
		else
			#save last key value pair in format key=value. If there is no value then add one
			if [[ "$last_param" == *=* ]]
			then
				args[i]="$last_param"
				i=$((i+1))
			else
				args[i]="$last_param""=true"
				i=$((i+1))
			fi
			last_param="$arg"
		fi
	else
		#If there is a key saved in the last parameter then this is its value
		if [ "$last_param" == "" ]
		then
			args[i]="$arg""=true"
			i=$((i+1))
			last_param=""
		else
			args[i]="$last_param""=""$arg"
			i=$((i+1))
			last_param=""
		fi
	fi
done

#save last key value pair in format key=value. If there is no value then add one
if [ "$last_param" != "" ]
then
	if [[ "$last_param" == *=* ]]
	then
		args[i]="$last_param"
	else
		args[i]="$last_param""=true"
	fi
fi

#run install jar with adjusted arguments
./bin/"$exe_filename" "$setup_jar" "$os_type" silent.install=true install.type="$install_type" chronicall.brand="$brand" logpath=../../ "${args[@]}"